const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const company_bank_accounts = sequelize.define(
    'company_bank_accounts',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

type: {
        type: DataTypes.ENUM,
      
      

        values: [

"MAIN",


"PAYROLL",


"VAT",


"OTHER"

        ],

      },

currency: {
        type: DataTypes.ENUM,
      
      

        values: [

"EUR",


"USD",


"GBP",


"PLN",


"CZK",


"RON",


"BGN",


"OTHER"

        ],

      },

bank_name: {
        type: DataTypes.TEXT,
      
      

      },

iban: {
        type: DataTypes.TEXT,
      
      

      },

bic: {
        type: DataTypes.TEXT,
      
      

      },

account_holder: {
        type: DataTypes.TEXT,
      
      

      },

is_default: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

is_active: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  company_bank_accounts.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity















































//end loop



    db.company_bank_accounts.belongsTo(db.companies, {
      as: 'company',
      foreignKey: {
        name: 'companyId',
      },
      constraints: false,
    });




    db.company_bank_accounts.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.company_bank_accounts.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return company_bank_accounts;
};


